<?php
	
	//cre la classe carte qui comporte une valeur et un maillon de chaine
	class carte
	{
		private $valeur;
		private $next;
		
		public function setval($valeur) { $this->valeur = $valeur; }
		public function getval() { return $this->valeur; }
		
		public function setnext($next) { $this->next=$next; }
		public function getnext() { return $this->next; }
	}

	//gnre un paquet de carte mlanger
	function paquet($nbc)
	{
		$i=1;
		do
		{	$j= rand(1,$nbc);
			if (!isset($clef[$j])) $clef[$j]=$i++;
		} while ($i<=$nbc);
		return $clef;
	}

	//Gnre la chaine du paquet de carte
	function genchaine($clefc, $clef, $nbc)
	{
		$clefc[1]=new carte();
		$clefc[1]->setval($clef[1]);
		
		for($i=2; $i<=$nbc; $i++)
		{
			$clefc[$i]=new carte();
			$clefc[$i-1]->setnext($clefc[$i]);
			$clefc[$i]->setval($clef[$i]);
		}
		$clefc[$nbc]->setnext($clefc[1]);
		return $clefc[$nbc];
	}

	//Recherche et renvoie la carte qui prcde celle qui contient la valeur mise en parametre
	function recherche($queue, $valeur)
	{
		$courant=$queue->getnext();
		do {
			if($courant->getnext()->getval()==$valeur)
				return $courant;
			else $courant=$courant->getnext();
		} while ($valeur!=0);
	}
	
	//Dcale la carte mise en parametre du nombre de carte mis en parametre
	function recul ($queue, $element, $pas)
	{
		$temp=$element->getnext();
		for($i=0; $i<$pas; $i++)
		{
			if($queue==$element) $queue->setnext($temp->getnext());
			$element->setnext($temp->getnext());
			$element=$element->getnext();
			$temp->setnext($element->getnext());
			$element->setnext($temp);
		}
	}

	//Renvoie 0 si le Joker Noir apparait en premier et 1 si c'est le Joker Rouge
	function positionJoker($queue, $nbc)
	{
		$courant=$queue->getnext();
		for($i=1; $i<=$nbc; $i++)
		{
			switch ($courant->getval())	{
				case $nbc-1:
					return 0;
				case $nbc:
					return 1;
				default:
					$courant=$courant->getnext();
			}
		}
	}

	function fstsndjoker($first, $second, $queue)
	{
		//Traite le cas o les Joker ce trouvent aux extremits du paquet
		if( $first==$queue && $second==$queue ) return 1;
		//Traite le cas o le premier Joker ce trouvent en haut du paquet
		if( $first==$queue ) return 2;
		//Traite le cas o le second Joker ce trouvent  la fin du paquet
		if( $second==$queue ) return 3;
		//Traite le cas o les Jokers ce trouve au milieu du paquet
		return 0;
	}

	//Coupe en 3 le paquet au niveau des Joker et intervertie les deux paquets aux extremits
	function etape3($queue, $nbc)
	{
		if (positionJoker($queue, $nbc)) //Affecte les positions de coupe selon la position des Joker dans le paquet
		{
			$first=recherche($queue, 54);
			$second=recherche($queue, 53)->getnext();
		}
		else
		{
			$first=recherche($queue, 53);
			$second=recherche($queue, 54)->getnext();
		}
		switch (fstsndjoker($first, $second, $queue))
		{
			case 0:
			{
				$temp=$first->getnext();
				$first->setnext($second->getnext());
				if($first!=$queue->getnext())//Condition pour le cas particulier o $first est la tte
					$second->setnext($queue->getnext());
				$queue->setnext($temp);
				$queue=$first;
				break;
			}
			case 1:	break;
			case 2:
			{
				$queue=$second;
				break;
			}
			case 3:
			{
				$queue=$first;
				break;
			}
		}
		return $queue;
	}

	function etape4($queue) //Coupe le paquet par rapport  la dernire carte
	{
		if($queue->getval()>53) $valq=53; else $valq=$queue->getval();
		$posn=position($queue, $valq);
		position($queue, 53)->setnext($queue->getnext());
		$queue->setnext($posn->getnext());
		$posn->setnext($queue);
	}
	
	function position($queue, $pos) //Renvoie la pos-ieme carte du paquet
	{
		$temp=$queue;
		for ($i=0;$i<$pos;$i++)
			$temp=$temp->getnext();
		return $temp;
	}
	
	//gnre un code pour crypter le paquet
	function genlist($gen){
		$tab="";
		for($j=1; $j<=54; $j++)
		{
			$tab[$j]=($gen*$j)%54; //multiplication
			if($tab[$j]==0) $tab[$j]=54;
		}
		return $tab;
	}
	
	function hashpack($pack, $op)
	{
		$hash=genlist($pack[0]);
		if($op=="/") $hash=array_flip($hash); //inverse pour dcrypter
		for ($i=1; $i<=54; $i++)
			$tab[$i]=$hash[$pack[$i]];
		return $tab;
	}
?>